ConnectionProvider::InvalidConnection Class Reference

this class is used to mark invalid connections so they can be loaded and reported as invalid More...

Inheritance diagram for ConnectionProvider::InvalidConnection:
[legend]

## Public Member Functions

deprecated | constructor (string n_name, string n_desc, string n_url, *hash n_opts, string n_error, hash urlh)
| DEPRECATED: creates the invalid connection object. More...
| constructor (string name, string description, string url, hash attributes={}, hash options={})
| creates the invalid connection object More...
string | getType ()
| returns `"invalid"`
Public Member Functions inherited from ConnectionProvider::AbstractConnection
deprecated | constructor (string n_name, string n_desc, string n_url, bool n_monitor, *hash n_opts, hash n_urlh, *string n_safe_url, *bool n_enabled)
| creates the AbstractConnection object More...
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the AbstractConnection object More...
object | get (bool connect=True, *hash< auto > rtopts)
| returns the underlying connection object More...
hash< ConfigInfo > | getConfigHash ()
| returns a ConfigInfo hash of static configuration information about the connection More...
hash< ConnectionSchemeInfo > | getConnectionSchemeInfo ()
| Returns a default ConnectionSchemeInfo hash.
AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection, if supported More...
*hash< auto > | getDefaultOptions ()
| returns default options
hash< auto > | getExtendedInfo (*hash< auto > opts)
| Returns connection info plus any extended information returned by the connection. More...
hash< ConnectionInfo > | getInfo (*hash< auto > opts)
| returns a ConnectionInfo hash of information about the connection More...
hash< ConnectionInfo > | getInfo (bool with_password=False)
| returns a ConnectionInfo hash of information about the connection More...
*hash< auto > | getOptions ()
| returns static / initialization options
*hash< auto > | getRealOptions ()
| returns options for saving the connection's configuration information
*hash< auto > | getRuntimeOptions ()
| returns runtime options
auto | getTag (string tag)
| returns the value of the given tag or NOTHING if not present
auto | getTagEx (string tag)
| returns the value of the given tag or throws an exception if the tag is not set with a value More...
hash< auto > | getTags ()
| returns all tags associated with the connection
bool | hasDataProvider ()
| returns True if the connection returns a data provider with the getDataProvider() method More...
| parseTextOptions ()
| this method is called when parsing connection file definitions from text files when loading into the database More...
hash< PingInfo > | ping (bool throw_exception=False)
| returns a hash with the results of the ping operation More...

## Public Attributes

string | error = "unknown error"
| Error message provided by constructor's `attributes.error`.
Public Attributes inherited from ConnectionProvider::AbstractConnection
bool | debug_data = False
| debug data flag; to be used an an indication for a higher-level implementation
string | desc
| connection description
bool | enabled = True
| enabled/disabled indicator flag
hash< auto > | internal_info
| internal tags
date | last_check
| date/time of last check/ping
bool | locked = False
| locked/unlocked flag
bool | loopback = False
| set to True for loopback connections
bool | monitor
| monitoring flag
string | name
| connection name
*hash< auto > | opts
| connection options
*hash< auto > | orig_opts
| original connection options
string | safe_url
| "safe" URL (password information removed)
string | status = "not checked"
| status string; in case of a connection error this string will be the error string
hash< auto > | tags = {}
| connection tags; user-defined key-value pairs
bool | up = False
| connection status flag; set by monitoring or explicit pings/connections
date | updated
| date/time of last update
string | url
| connection URL (potentially with password info)
hash< auto > | urlh
| broken down URL hash (as returned by Qore::parse_url())

## Protected Member Functions

object | getImpl (bool connect=True, *hash rtopts)
| throws an exception because the object is invalid
hash | parseUrl (string url)
| Parse the URL to a hash. More...
Protected Member Functions inherited from ConnectionProvider::AbstractConnection
abstract object | getImpl (bool connect=True, *hash< auto > rtopts)
| this method must return the connection object corresponding to the object's configuration More...
string | getSafeUrl (hash< auto > urlh)
| creates a "safe" URL string with password information removed More...
hash< UrlInfo > | parseUrl (string url)
| Parse the URL to a hash. More...
hash< PingInfo > | pingIntern (hash< PingInfo > rv)
| performs the ping by executing get(); returns a PingInfo hash
hash< auto > | validateOptions (hash< auto > options)
| performs options validation in the constructor More...

## Additional Inherited Members

Static Public Attributes inherited from ConnectionProvider::AbstractConnection
static *code | post_processing
| optional code for default post-processing of objects created by getImpl(); must take the connection object and the object created as arguments

## Detailed Description

this class is used to mark invalid connections so they can be loaded and reported as invalid

## Member Function Documentation

## constructor() [1/2]

deprecated ConnectionProvider::InvalidConnection::constructor | ( | string | n_name,
|  | string | n_desc,
|  | string | n_url,
|  | *hash | n_opts,
|  | string | n_error,
|  | hash | urlh
| ) |  |

DEPRECATED: creates the invalid connection object.

Deprecated:
  since Qore 0.9

## constructor() [2/2]

ConnectionProvider::InvalidConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash | attributes = `{}`,
|  | hash | options = `{}`
| ) |  |

creates the invalid connection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Additional Attributes

- `error` a custom error string

## parseUrl()

hash ConnectionProvider::InvalidConnection::parseUrl | ( | string | url | ) |

protected

Parse the URL to a hash.

Parameters

  url | a string with url

Returns
  hash with url - string as url

The reason for this is to avoid a unwanted Qore::parse_url() call in connections with custom parseUrl() implementation.